package tests;

import static org.junit.Assert.*;

import java.io.StringReader;
import java.util.Arrays;
import java.util.Collection;

import org.junit.Test;

import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import rabinizer.exec.*;
import rabinizer.formulas.Formula;
import rabinizer.parser.LTLParser;

@RunWith(value = Parameterized.class)
public class ConstructSegmentAutomaton {

	private String input;
	private String expected;	
	
	public ConstructSegmentAutomaton(String input, String expected) {
		this.input = input;
		this.expected = expected;
	}

    @Parameters
	public static Collection<Object[]> data() {
        Object[][] data = new Object[][] { 
        		{ "a", "" },                       // TODO: pass this test
        		{ "v0 & X v1", "" },               // TODO: pass this test
        		{ "(a & X b) | (b & X X a)", "" }, // TODO: pass this test
        };
        return Arrays.asList(data);
    }

	@Test
	public void pushTest() {
		System.out.println(this.getClass().getCanonicalName()+" : "+input);
		
		LTLParser parser = new LTLParser(new StringReader(input));
		Formula inf = null;
		try { inf = parser.parse(); }
		catch (Exception e) { assertTrue(false); }
		
		Misc.initializeValuations(Misc.bijectionIdAtom.size());
		SegmentAutomaton sA = new SegmentAutomaton(inf, Misc.valuations);
		
		System.out.println("input:    " + sA.toString());
		System.out.println("expected: " + expected);
		assertTrue(sA.toString().equals(expected));
	}
}
