package tests;

import static org.junit.Assert.*;


import java.io.StringReader;
import java.util.Arrays;
import java.util.Collection;

import org.junit.Test;

import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import rabinizer.formulas.Formula;
import rabinizer.parser.LTLParser;

@RunWith(value = Parameterized.class)
public class IsProgressFormula {

	private String input;
	private boolean expected;	
	
	public IsProgressFormula(String input, boolean expected) {
		this.input = input;
		this.expected = expected;
	}

	@Parameters
	public static Collection<Object[]> data() {
		Object[][] data = new Object[][] { 
				{ "X (a | F b)", true },
				{ "(X X a) | F b", true },
				{ "X (X a & X b)", true },
				{ "X (F b & G a | X b)", true },
				
				{ "X F b", false },
				{ "X (F b & G a)", false },
		};
		return Arrays.asList(data);
	}

	@Test
	public void pushTest() {
		System.out.println("\n"+this.getClass().getCanonicalName());
		
		LTLParser parser = new LTLParser(new StringReader(input));
		Formula inf = null;
		try { inf = parser.parse(); }
		catch (Exception e) { assertTrue(false); }
		
		assertTrue(inf.isProgressFormula() == expected);
	}
}
